package RalliJava;

import java.io.PrintStream;
import java.util.Random;

/**
 * @author idamk
 * @version 12.2.2025
 *
 */
public class Ralli {



    /**
     * @author idamk
     * @version 12.2.2025
     * Vois kirjottaa luokan CRC-kortin vastuut
     *
     */
    private int     tunnusNro;
    private int     htunnusNro;
    private String  rallinNimi                = "";
    private String  sijainti            = "";
    private int     osallistujienMaara;
    private String  jarjestaja          = "";
    //private String  pvm          = "";
    private int  ilmottautumismaksu  = 0;
    //private String  ilmottautuneet      = "";
    //private String  nettisivut          = "";
    //private String  tulokset            = "";
    
    private static int seuraavaNro = 0;    
        
        /**
         * @return rallille seuraava identifioiva tunnusnumero
         * 
         */
        public int rekisteroi() {
            this.tunnusNro = seuraavaNro;
            seuraavaNro++;
            return tunnusNro;
        }
        
        
        /**
         * Vastaa randomisti eri henkilöiden tietoja
         * @param nro tunnusnumero
         */
        public void vastaaRalli(int nro) {
            
            htunnusNro = nro;
            Random r = new Random();
            int n = r.nextInt(4);
            int sr = r.nextInt(5);
            int kp = r.nextInt(7);
            osallistujienMaara = r.nextInt(66);
            //pvm = r.nextInt(100);
            ilmottautumismaksu = r.nextInt(100);
            
            if(n==0) rallinNimi = "Ralliräminät";
            if(n==1) rallinNimi = "Kilvanajo";
            if(n==2) rallinNimi = "Ralli123";
            if(n==3) rallinNimi = "Pärinät";
            
            if(sr==0) jarjestaja = "Jyväskylän ralliveikot";
            if(sr==1) jarjestaja = "Jämsän autopojat";
            if(sr==2) jarjestaja = "Kuopion nopeet";
            if(sr==3) jarjestaja = "Rovaniemen nopeet shamaanit";
            if(sr==4) jarjestaja = "Keuruun pikamannet";
            
            if(kp==0) sijainti = "Jyväskylä";
            if(kp==1) sijainti = "Jämsä";
            if(kp==2) sijainti = "Kuopio";
            if(kp==3) sijainti = "Seinäjoki";
            if(kp==4) sijainti = "Hyvinkää";
            if(kp==5) sijainti = "Rovaniemi";
            if(kp==6) sijainti = "Keuruu";
            
            //Ralli ralli = new Ralli(tunnusNro, rallinNimi, sijainti, jarjestaja, osallistujienMaara, ilmottautumismaksu);
            //ralli.tulosta(System.out);
        }
        
        
        /**
         * Kun halutaan tietää jonkun rallin identifioiva tunnusnumero
         * @return tunnusnro
         */
        public int getTunnusNro() {
            return tunnusNro;
        }
        
        /**
         * Alustaa henkilön
         */
        public Ralli() {
            //ei välttämättä tarttis
        }
        
 
        /**
         * @param tunnusNro id
         * @param rNimi nimi
         * @param sijainti missä
         * @param jarjestaja seura
         * @param osallistujienMaara määrä
         * @param ilmottautumismaksu koko
         */
        /*
        public Ralli(int tunnusNro, String rNimi, String sijainti, String jarjestaja, int osallistujienMaara, int ilmottautumismaksu) {
        this.tunnusNro = tunnusNro;
        this.rallinNimi = rNimi;
        this.jarjestaja = jarjestaja;
        this.sijainti = sijainti;
        this.osallistujienMaara = osallistujienMaara;
        this.ilmottautumismaksu = ilmottautumismaksu;
        }
        
        */
        
        /**
         * @param tulostettava tietovirta mitä tulostetaan
         */
        public void tulosta(PrintStream tulostettava) {
            tulostettava.println(String.format("%03d", tunnusNro, 3) + " " + rallinNimi);
            tulostettava.println("Sijainti: " + sijainti);
            tulostettava.println("Järjestäjäseura: " + jarjestaja);
            tulostettava.println("Osallistujia " + osallistujienMaara + "kpl");
            tulostettava.println("Ilmottautumismaksu " + ilmottautumismaksu + "€");
            System.out.println("");
        }
        
        
        /**
         * @return rallin nimi
         */
        public String getNimi() {
            return this.rallinNimi;
        }
        
        
        /**
         * @param args ei käytössä
         */
        public static void main(String[] args) {
            Ralli kuopio = new Ralli();
            Ralli pohjanmaa = new Ralli();
            kuopio.rekisteroi();
            kuopio.vastaaRalli(0);
            kuopio.tulosta(System.out);
            pohjanmaa.rekisteroi();
            pohjanmaa.vastaaRalli(1);
            pohjanmaa.tulosta(System.out);
            //elfyn.rekisteroi();
            //elfyn.vastaahlo();
            //elfyn.tulosta(System.out);
            
            
        }
    }


