package RalliJava;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;


/**
 * @author idamk
 * @version 12.2.2025
 *
 */
public class Rallit {
    
    private Collection<Ralli> alkiot = new ArrayList<Ralli>();
    
    int lkm = 0;

    /**
     * Alustus
     */
    public Rallit() {
        //Ei tarvi tehdä mitään
    }

    
    /**
     * Haetaan kaikki henkilön osallistumat rallit
     * @param tunnusNro rallin tunnusnumero
     * @return lista ralleista johon haluttu henkilö on osallistunut
     */
    public List<Ralli> annaRallit(int tunnusNro) {
        List<Ralli> loydetyt = new ArrayList<Ralli>();
        for (Ralli ralli:alkiot) //ITERAATTORI
            if(ralli.getTunnusNro() == tunnusNro) loydetyt.add(ralli);
        return loydetyt;
    
    }

    
   
    /**
     * @param ralli lisättävä
     */
    public void lisaa(Ralli ralli) {
        alkiot.add(ralli);
    }
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Rallit rallit = new Rallit();
        
        
            Ralli pohjanmaa = new Ralli();
            Ralli kuopio = new Ralli();
            Ralli secto = new Ralli();
            pohjanmaa.rekisteroi();
            pohjanmaa.vastaaRalli(0);
            kuopio.rekisteroi();
            kuopio.vastaaRalli(1);
            secto.rekisteroi();
            secto.vastaaRalli(1);
            
            rallit.lisaa(pohjanmaa);
            rallit.lisaa(kuopio);
            rallit.lisaa(secto);
            pohjanmaa.tulosta(System.out);
            kuopio.tulosta(System.out);
            secto.tulosta(System.out);

            System.out.println("======================== Rallit testi ========================");
            
            List<Ralli> rallit2 = rallit.annaRallit(2);
            
            
            // Tulostaa halutun (yläällä indeksi) rallin luoduista
            for (Ralli ral : rallit2) {
                System.out.print(ral.getTunnusNro() + " ");
                ral.tulosta(System.out);
            } 
            
   
            
        

    }

}